#! /bin/bash

service_array=(MQTTSample)
ProductKey=""
DeviceName=""
DeviceSecret=""
CustomHost=""
CustomPort=""

#Terminate the service started
stop_services() {
for service in ${service_array[@]}
do
	num=$(ps -eo user,pid,ppid,stat,args | grep "${service}" | grep -v grep | wc -l)
	if [ $num -ne 0 ];then
		${Q}echo -e "[  \033[0;31m-\033[0m  ]  Stop Running Service:  ${service}"
		ps -eo user,pid,ppid,stat,args | grep "${service}" | grep -v "grep" | awk '{print $2}' | xargs kill -15 >>/tmp/linkedge.log 2>&1
		sleep 1
	fi
done
}

start_services(){
	i=0
	for service in ${service_array[@]}
    do
        cd ../bin
        if [ ${#CustomHost} -ge 1 ]; then
            (./${service} ${ProductKey} ${DeviceName} ${DeviceSecret} ${CustomHost} ${CustomPort} &>/dev/null &)
        else
            (./${service} ${ProductKey} ${DeviceName} ${DeviceSecret} &>/dev/null &)
        fi
        cd - &>/dev/null
        ${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: ${service}"
        sleep 1
        i=$i+1
    done
}

cd `dirname $0`
if [ $# -lt 3 ]; then
    echo "usage: ./iot_gateway_start_lite.sh ProductKey DeviceName DeviceName."
    exit 0
fi

ProductKey=$1
DeviceName=$2
DeviceSecret=$3

if [ $# -eq 5 ]; then
    CustomHost=$4
    CustomPort=$5
    echo "----->>>>> $CustomHost ${CustomPort}"
fi

${Q}echo "ProductKey: ${ProductKey} DeviceName: ${DeviceName}"

${Q}echo "----------------------------------------------------------"
${Q}echo -e "              \033[0;31mStop Link IoT Edge Lite Running Services\033[0m"
${Q}echo "----------------------------------------------------------"
stop_services
${Q}echo ""

start_services

${Q}echo "----------------------------------------------------------"
${Q}echo -e "           \033[32mStart Link IoT Edge Services Success\033[0m   "
${Q}echo "----------------------------------------------------------"
${Q}echo ""

